- release 3 (by relup.sh)
[packages/VirtualBox.git] / mount.vdi
1 #!/bin/sh
2 #==============================================================================
3 # mount.vdi
4 #   Copyright (C) Elan Ruusam√§e <glen@pld-linux.org>, 2008
5 #
6 #   This program is free software; you can redistribute it and/or
7 #   modify it under the terms of the GNU General Public License as
8 #   published by the Free Software Foundation; either version 2 of
9 #   the License, or (at your option) any later version.
10 #
11 #   This program is distributed in the hope that it will be useful,
12 #   but WITHOUT ANY WARRANTY; without even the implied warranty of
13 #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14 #   General Public License for more details.
15 #
16 #   You should have received a copy of the GNU General Public
17 #   License along with this program; if not, write to:
18 #   Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
19 #   Boston, MA  02110-1301  USA
20 #
21 #   -- For details, see the file named "LICENSE.GPLv2"
22 #==============================================================================
23
24 # Sanitize environment
25 export PATH=/bin:/sbin:/usr/bin:/usr/sbin
26
27 # Commands
28 LOSETUP=/sbin/losetup
29 MOUNT=/bin/mount
30 PARTED=/usr/sbin/parted
31 SED=/bin/sed
32
33 PROGRAM=${0##*/}
34 MOUNTARGS=
35 OPTIONS=
36 FSTYPE=
37
38 USAGE="<VDI image> <mountpoint> [-o options,...]
39
40 Options:
41       partition=<number>              Specify partition to mount
42       fstype=<fstype>                 Specify FS type instead of autodetecting
43 "
44
45 # This is braindead, two first args are dev and mountpoint if invoked from
46 # mount(1), but could be option if invoked from mount.vdi(1)
47 if [ -n "$1" ] && [[ "$1" != -* ]]; then
48         DEVICE=$1
49         shift
50 fi
51 if [ -n "$1" ] && [[ "$1" != -* ]]; then
52         MOUNTPOINT=$1
53         shift
54 fi
55
56 while :; do
57         case "$1" in
58         -h | "-?" )
59                 echo >&2 "Usage: $PROGRAM $USAGE"
60                 exit 0 ;;
61         -o)
62                 OPTIONS="$2";
63                 shift ;;
64         -n)
65                 MOUNTARGS="$MOUNTARGS $1"
66                 ;;
67         -?* )
68                 echo >&2 "$PROGRAM: unrecognized option: $1"
69                 exit 1 ;;
70         *)
71                 break ;;
72         esac
73         shift
74 done
75
76 if [ -z "$DEVICE" ]; then
77         echo >&2 "$PROGRAM: device to mount not specified"
78         exit 1
79 fi
80
81 if [ -z "$MOUNTPOINT" ]; then
82         echo >&2 "$PROGRAM: mount point not specified"
83         exit 1
84 fi
85
86 if [ ! -f "$DEVICE" ]; then
87         echo >&2 "$PROGRAM: $DEVICE is not a file"
88         exit 1
89 fi
90
91 if [ ! -d "$MOUNTPOINT" ]; then
92         echo >&2 "$PROGRAM: $MOUNTPOINT is not a directory"
93         exit 1
94 fi
95
96 # check magic
97 magic=$(head -n 1 "$DEVICE")
98 case "$magic" in
99 "<<< innotek VirtualBox Disk Image >>>")
100         ;;
101 "<<< Sun VirtualBox Disk Image >>>")
102         ;;
103 "<<< Oracle VM VirtualBox Disk Image >>>")
104         ;;
105 *)
106         echo >&2 "$PROGRAM: $DEVICE: bad magic, not VDI image"
107         exit 1
108 esac
109
110 MOUNTOPTIONS=
111 PARTITION=
112 OFFSET=
113 OLDIFS=$IFS
114 IFS=", "
115 for opt in $OPTIONS; do
116         KEY=${opt%=*};
117         VAL=${opt#*=};
118         case "$KEY" in
119         part|partition)
120                 PARTITION="$VAL"
121                 ;;
122         fstype)
123                 FSTYPE="$VAL"
124                 ;;
125         *)
126                 if [ -z "$MOUNTOPTIONS" ]; then
127                         MOUNTOPTIONS="$opt"
128                 else
129                         MOUNTOPTIONS="$MOUNTOPTIONS,$opt"
130                 fi
131         ;;
132         esac
133 done
134 IFS="$OLDIFS"
135
136 if [ -z "$PARTITION" ]; then
137         echo >&2 "$PROGRAM: missing partition option"
138         exit 1
139 fi
140
141 # offset when disk starts
142 dskoff=8704
143
144 # find free loop device. XXX race possible
145 imgdev=$($LOSETUP -f) || exit 1
146 $LOSETUP $imgdev -o $dskoff "$DEVICE"
147 dump=$($PARTED -s -m $imgdev unit B print)
148 $LOSETUP -d $imgdev || exit 1
149
150 partoff=$(echo "$dump" | $SED -ne "s/^$PARTITION:"'\([0-9]*\)B:.*/\1/p')
151 OFFSET=$((dskoff + partoff))
152
153 if [ -z "$partoff" -o -z "$OFFSET" ]; then
154         echo >&2 "$PROGRAM: couldn't figure out offset, perhaps out of range?"
155         exit 1
156 fi
157
158 if [ -z "$MOUNTOPTIONS" ]; then
159         MOUNTOPTIONS="loop,offset=$OFFSET"
160 else
161         MOUNTOPTIONS="$MOUNTOPTIONS,loop,offset=$OFFSET"
162 fi
163
164 # $MOUNTPOINT might not exist as mount can try to read it from /etc/fstab
165 $MOUNT $MOUNTARGS ${FSTYPE:+-t "$FSTYPE"} ${MOUNTOPTIONS:+-o "$MOUNTOPTIONS"} "$DEVICE" "$MOUNTPOINT"
166 if [ $? -ne 0 ]; then
167         echo >&2 "$PROGRAM: error mounting $DEVICE"
168 fi
This page took 0.059994 seconds and 3 git commands to generate.